
# interpolation of observations ----

#fer iteracions per cada hora
df_obs_i <- df_obs_sub[1,] %>% 
  pivot_longer(cols=starts_with("ES"),names_to="ref_obs") %>%
  na.omit()

df_obs_i <- df_obs_i %>%
  dplyr::select(-ZAL)

obs_data <- merge(local_stations, df_obs_i, by = "ref_obs", all.x=F, all.y=T)  

#mapview(obs_data, zcol="value")


#config the coordinates in UTM
sp::proj4string(obs_data)  <- crs_latlon
if (compute_in_UTM) {
  obs_data <- spTransform(obs_data, sp::CRS(crs_utm))
}

# Variogram fitting (weights of each station)
pollutant.fit_ok_obs <- automap::autofitVariogram(formula=value~1, input_data=obs_data,model="Gau", fix.values=c(0,NA,NA),
                                              miscFitOptions = list(min.np.bin=1))

# Set gstat object  (pollutant~1 lineal estimation)                   
ok_gstat <- gstat(formula=value~1, data = obs_data, model = pollutant.fit_ok_obs$var_model, nmax=100)  # transform the variogram to a gstat (geostatistics)

# Interpolation of the obs at model grid
interpolated_obs <- predict(object=ok_gstat, newdata=df_model) 

# !!forcing concentrations to be positive
interpolated_obs$var1.pred[interpolated_obs$var1.pred<0] <- 0


#mapview(interpolated_obs, zcol="var1.pred")

#guardar la interpolació de les obs, fer el loocv a cada estacio i comparar amb els resultats de uk, quin es el best
loocv_interpolation_obs  <- krige.cv(value~1,
                                 obs_data,
                                 pollutant.fit_ok_obs$var_model)


ok_obs_loocv_h             <- matrix(data=loocv_interpolation_obs@data$var1.pred, nrow=1)
colnames(ok_obs_loocv_h)   <- llista_loocv@data$ref_obs
LOOCV_obs_total            <- bind_rows(as.data.frame(LOOCV_obs_total),as.data.frame(ok_obs_loocv_h))


if (save_OK_obs){
  saveRDS(object=interpolated_obs$var1.pred, file=paste0(save_result,"interpolated_obs_",pollutant,"_df.rds"))
  print("interpolated_obs_with_OK saved")
} else {
  print("interpolated_obs_with_OK have not been saved")
}

# loocv of obs interpolation with ok -------------------------------
