start_time_UK_LOOCV <- Sys.time()


#LOOCV_total and model_raw_at_AQMS is created empty to fill it later with LOOCV and raw model data respectively
if (execute_uk) {
  UK_total_df                  <- list() #we will have a large list with a data.frame for each hour/day
  UK_total_uncert_df           <- list() 
}
if (execute_loocv) {
  LOOCV_total           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0)
  colnames(LOOCV_total) <- local_stations$ref_obs 
  
  LOOCV_obs_total           <- matrix(NA,ncol=nrow(local_stations@data),nrow=0)
  colnames(LOOCV_obs_total) <- local_stations$ref_obs
  # # delete suffixes and prefixes in the name of stations (these appear when loading stations from ghost)
  # colnames(LOOCV_total) <- local_stations$ref_obs %>%
  #   gsub("STA_","",.) %>% gsub("\\_.*","",.) %>% gsub("STA-","",.) 
}

model_raw_at_AQMS <- model_raw_at_AQMS_df

# TODO moure això al script de OK
# TODO CHECK QUE PASSA A L'OCTUBRE
if(any(duplicated(model_raw_at_AQMS$date))){
  model_raw_at_AQMS$date[duplicated(model_raw_at_AQMS$date)] <- model_raw_at_AQMS$date[duplicated(model_raw_at_AQMS$date)] + dhours(1)
}

# Lists to save the slope and the interception between observations and model:
slope_v  <-  array(NA,dim = length_loop)
inter_v  <-  array(NA,dim = length_loop)
r_v      <-  array(NA,dim = length_loop)


# Loop UK - LOOCV ############################################################
date_0 <- df_uk_observations[1,"date"] %>%
  lubridate::date()

count_i <- 0
count_raw <- 0
count_obs <- 0

print("Loop UK - LOOCV")
#starting OK and LOOCV:
for(i in 1:length_loop) {
  # for(i in 1:10) {
  # i <- 1
  # date_i <- available_dates_model[i]
  
  # date_i <- dates[i]
  
  if(time_resolution=="daily"){
    date_i <- dates[i]
    date_i <- as.Date(date_i,format="%Y%m%d",tz="UTC")
  }else if(time_resolution=="hourly"){
    date_i <- date_times[i,1]
    date_i <- as.POSIXct(date_i,format="%Y%m%d %H",tz="UTC")
  }
  
  count_i <- count_i+1
  
  print(paste0("loop UK or LOOCV: ", i, " (",date_i,")"))
  
  #extract observations hourly
  df_obs_hour <- subset(df_uk_observations[i,], select = -c(date))
  
  # #To avoid what we suppose wrong observations, we will substitute the values higher than limit microg/m3
  # Get the row and column indices of values that exceed the limit
  indices <- which(df_obs_hour > limit, arr.ind = TRUE)
  
  # Check if any values exceed the limit
  if (nrow(indices) > 0) {
    # Modify the values that exceed the limit
    # df_obs_hour[indices] <- limit
    df_obs_hour[indices] <- NA
    
    # Print a message
    message(paste0("Observations exceeding the limit ", limit,
                   " microg/m3 (mg/m3 for CO) have been ignored. The number of observations modified are: ", 
                   nrow(indices), " in day/hour: ", i))
  }
  
  #interpolation of the observations (ok):
  df_obs_i <- df_obs_hour %>% 
    pivot_longer(cols=starts_with("ES"),names_to="ref_obs") %>%
    na.omit()
  
  #df_obs_i <- df_obs_i %>%
    #dplyr::select(-ZAL)
  
  obs_data <- merge(local_stations, df_obs_i, by = "ref_obs", all.x=F, all.y=T) 
  
  #config the coordinates in UTM
  sp::proj4string(obs_data)  <- crs_latlon
  if (compute_in_UTM) {
    obs_data <- spTransform(obs_data, sp::CRS(crs_utm))
  }
  
  # Variogram fitting (weights of each station)
  pollutant.fit_ok_obs <- automap::autofitVariogram(formula=value~1, input_data=obs_data,model="Gau", fix.values=c(0,NA,NA),
                                                    miscFitOptions = list(min.np.bin=1))
  
  # Set gstat object  (pollutant~1 lineal estimation)                   
  ok_gstat <- gstat(formula=value~1, data = obs_data, model = pollutant.fit_ok_obs$var_model, nmax=100)  # transform the variogram to a gstat (geostatistics)
  
  # Interpolation of the obs at model grid
  interpolated_obs <- predict(object=ok_gstat, newdata=df_model) 
  
  # !!forcing concentrations to be positive
  interpolated_obs$var1.pred[interpolated_obs$var1.pred<0] <- 0
  
  #loocv of ok 
  loocv_interpolation_obs  <- krige.cv(value~1,
                                       obs_data,
                                       pollutant.fit_ok_obs$var_model)
  
  ok_obs_loocv_h             <- matrix(data=loocv_interpolation_obs@data$var1.pred, nrow=1)
  colnames(ok_obs_loocv_h)   <- obs_data@data[["ref_obs"]]
  LOOCV_obs_total            <- bind_rows(as.data.frame(LOOCV_obs_total),as.data.frame(ok_obs_loocv_h))
  
  
  
  
  #raw model:
  df_model_uk <- model[,,i]
  
  if (!any(is.na(df_model_uk))){
    df_model_uk <- data.frame(lat=lat_model,lon=lon_model,pollutant_model=sapply(df_model_uk,as.matrix))
    coordinates(df_model_uk)     <- ~lon+lat
    sp::proj4string(df_model_uk) <- crs_latlon
    
    #config the coordinates in UTM
    if (compute_in_UTM) {
      df_model_uk <- spTransform(df_model_uk, sp::CRS(crs_utm))
    }
    
    
    #ok_hour <- model_raw_at_AQMS[i,-which(names(model_raw_at_AQMS)=="date")]
    
    ok_hour <- model_raw_at_AQMS %>% 
      dplyr::filter(date==date_i) %>%
      dplyr::select(-date)
    
    
    df_loocv <- data.frame(lat=local_stations@coords[,2],
                           lon=local_stations@coords[,1],
                           pollutant_model=as.numeric(ok_hour[1,]),
                           ref_obs=local_stations@data$ref_obs) 
    
    # df_loocv$ref_obs <- df_loocv$ref_obs %>%
    #   gsub("STA_","",.) %>% gsub("\\_.*","",.) %>% gsub("STA-","",.) 
    
    # remove rows with duplicated stations
    df_loocv <- df_loocv[!duplicated(df_loocv$ref_obs),]
    
    df_obs_loocv <- data.frame(pollutant_obs = as.numeric(df_obs_hour[1,]), 
                               ref_obs = colnames(df_obs_hour))
    
    llista_loocv <- merge(df_loocv, df_obs_loocv, by = "ref_obs")
    llista_loocv <- na.omit(llista_loocv) 
    
    # remove duplicates (there are stations that appear twice or more)
    # this would cause the UK to be NA everywhere
    llista_loocv <- llista_loocv %>% 
      distinct(ref_obs, .keep_all = T) %>%
      distinct(x=round(lat,5), .keep_all=T) %>% dplyr::select(-x)
    
    #!!! require at least 4 stations with observations to compute a variogram 
    if (sum(!is.na(llista_loocv$pollutant_obs)) >= 4){
      
      coordinates(llista_loocv)        <- ~lon+lat
      sp::proj4string(llista_loocv)    <- crs_latlon
      
      #config the coordinates in UTM
      if (compute_in_UTM) {
        llista_loocv <- spTransform(llista_loocv, sp::CRS(crs_utm))
      } else {
        sp::proj4string(llista_loocv) <- crs_latlon
      }
      
      # remove stations that have the same coordinates although different names
      # llista_loocv <- llista_loocv[-zerodist(llista_loocv,zero=0.01)[,1],] 
      
      # Compute LOOCV variogram
      # pollutant.fit_loocv <- automap::autofitVariogram(formula=pollutant_obs~pollutant_model,
      #                                                  input_data=llista_loocv, 
      #                                                  verbose=FALSE,
      #                                                  fix.values=c(0,NA,NA))
      
      # try to fit a variogram and handle errors using other variograms if available
      tryCatch(
        expr = {
          pollutant.fit_loocv <- automap::autofitVariogram(formula=pollutant_obs~pollutant_model,
                                                           input_data=llista_loocv,
                                                           verbose=FALSE,
                                                           fix.values=c(0,NA,NA))
        },
        error = function(e){
          if(exists("pollutant.fit_loocv")){
            print("Warning: could not fit variogram. Using previous variogram.")
          }else if(file.exists(variogram_uk)){
            print("Warning: could not fit variogram. Previous variogram not found. Using emergency variogram.")
            pollutant.fit_loocv <- readRDS(variogram_uk)
          }else{
            print("Warning: could not fit variogram. No variograms found. Skipping...")
          }
        }
      )
      # if no variogram fitted or reused, go to next date 
      if(!exists("pollutant.fit_loocv")){
        next
      }
      
      # Retrieve emergency Variogram if range of the current Variogram is negative
      if(any(pollutant.fit_loocv$var_model$range<0)){
        print('UK Variogram had negative range')
        pollutant.fit_loocv <- readRDS(variogram_uk)
      }
      
      #pollutant.fit_loocv$var_model[2,"range"] <- pollutant.fit_loocv$var_model[2,"range"]
      
      #coef(lm(pollutant_obs ~  pollutant_model , llista_uk))['pollutant_model'] is the same as slope:
      slope <- summary(lm(pollutant_obs ~  pollutant_model , llista_loocv))$coefficients[,1][-1]
      interc <- ((lm(pollutant_obs ~  pollutant_model , llista_loocv))$coefficients)[1]
      r <- cor(llista_loocv$pollutant_obs,llista_loocv$pollutant_model, method = "pearson")
      #p     <-summary(lm(pollutant_obs ~  pollutant_model , llista_uk))$coefficients[,4][-1] #p value.
      
      #plot(llista_loocv$pollutant_model,llista_loocv$pollutant_obs)
      
      slope_v[i]  <-  slope
      inter_v[i]  <- interc
      r_v[i]      <- r
      
      if(slope[1] < -20){
        
        if(execute_uk){
          # UK
          uk_interpolation              <- as.data.frame(df_model_uk$pollutant_model)
          colnames(uk_interpolation)    <- c("var1.pred")
          coordinates(uk_interpolation) <- df_model_uk@coords
          
          #config the coordinates in UTM
          if (compute_in_UTM) {
            sp::proj4string(uk_interpolation) <- crs_utm
          } else {
            sp::proj4string(uk_interpolation) <- crs_latlon
          }
        }
        
        
        if(execute_loocv){
          # LOOCV
          #loocv_interpolation              <- as.data.frame(llista_loocv$pollutant_model)
          #colnames(loocv_interpolation)    <- c("var1.pred")
          loocv_interpolation <- data.frame(var1.pred= array(NA,dim=length(llista_loocv$pollutant_model)))
          coordinates(loocv_interpolation) <- llista_loocv@coords
          
          #config the coordinates in UTM
          if (compute_in_UTM) {
            sp::proj4string(loocv_interpolation) <- crs_utm
          } else {
            sp::proj4string(loocv_interpolation) <- crs_latlon
          }
        }
        
        print(paste0("The slope in ", date_i, " is ", slope, 
                     ". We did not apply LOOCV, raw-model value is picked for this step"))
        
      }else {
        
        #Save the first variogram executed for a certain pollutant if we already don't have one saved:
        if (!file.exists(variogram_uk)) {
          saveRDS(pollutant.fit_loocv,variogram_uk)
        }
        
        if(execute_uk){
          # UK
          uk_gstat <- gstat(formula=pollutant_obs~pollutant_model,
                            data=llista_loocv, 
                            model = pollutant.fit_loocv$var_model)
          
          uk_interpolation  <- predict(object=uk_gstat, newdata=df_model_uk)
        }
        
        if(execute_loocv){
          # LOOCV
          loocv_interpolation  <- krige.cv(pollutant_obs~pollutant_model,
                                           llista_loocv,
                                           pollutant.fit_loocv$var_model)
        }
      }
      
      if(execute_uk){
        
        # for so2, replace values below 1 with 1, and round to nearest integer
        if(pollutant=="so2"){
          uk_interpolation@data$var1.pred <- round(uk_interpolation@data$var1.pred)
          loocv_interpolation@data$var1.pred <- round(loocv_interpolation@data$var1.pred)
          
          uk_interpolation@data$var1.pred[uk_interpolation@data$var1.pred<1] <- 1
          loocv_interpolation@data$var1.pred[loocv_interpolation@data$var1.pred<1] <- 1
        }
        
        UK_total_df[[count_i]]              <- uk_interpolation@data$var1.pred
        UK_total_uncert_df[[count_i]]       <- uk_interpolation@data$var1.var
        
      }
      if(execute_loocv){
        uk_loocv_h             <- matrix(data=loocv_interpolation@data$var1.pred, nrow=1)
        colnames(uk_loocv_h)   <- llista_loocv@data$ref_obs
        # LOOCV_total            <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
        LOOCV_total            <- bind_rows(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
        
        
        # compare LOOCV with the raw model and obs
        # if the RMSE in the LOOCV is higher than the raw model, we will take the raw model instead
        #TODO compute also the interpolation of observations and check if this is better than raw/UK (ADA, codi a part interpol_obs)
        check <- llista_loocv %>% 
          as.data.frame() %>%
          # mutate(pollutant_uk = as.numeric(LOOCV_total[!is.na(LOOCV_total)]))
          mutate(pollutant_uk = as.numeric(uk_loocv_h)) 
        colnames(check) <- c("ref_obs","raw","obs","lon","lat","uk")
        
        ok_obs_loocv_h <- t(ok_obs_loocv_h)
        check$ok <- ok_obs_loocv_h[match(check$ref_obs, rownames(ok_obs_loocv_h))]
        
        #convert columns of raw and uk to two different rows
        uk_raw_obs <- check %>%
          pivot_longer(cols=c("raw","uk", "ok"), names_to="type", values_to="model")
        
        Summary_stats <- openair::modStats(uk_raw_obs, obs="obs", mod="model", type="type")
        # print(Summary_stats)
        
        best <- Summary_stats$type[which.min(Summary_stats$RMSE)] %>% as.character()
        
        # if the raw model has lower RMSE, then replace the UK with the raw model, also in the LOOCV
        if(best=="raw" | sum(!is.na(uk_loocv_h))<4){
          print("**Using raw model instead of UK**")
          count_raw <- count_raw+1
          
          UK_total_df[[count_i]]              <- as.numeric(df_model_uk$pollutant_model)
          UK_total_uncert_df[[count_i]]       <- rep(NA, length(df_model_uk))   ##and fill uncertainty with nans to clarify that uk was not used?
          
          # replace also LOOCV, but first delete the last row because we already filled it to do the check
          LOOCV_total <- LOOCV_total[-nrow(LOOCV_total),]
          LOOCV_total <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(ok_hour))
        }
        
        if(best=="ok" | sum(!is.na(uk_loocv_h))<4){
          print("**Using interpolation of the observations instead of UK**")
          count_obs <- count_obs+1
          
          UK_total_df[[count_i]]              <- as.numeric(interpolated_obs@data[["var1.pred"]])
          UK_total_uncert_df[[count_i]]       <- rep(NA, length(df_model_uk))   ##and fill uncertainty with nans to clarify that uk was not used?
          
          # replace also LOOCV, but first delete the last row because we already filled it to do the check
          LOOCV_total <- LOOCV_total[-nrow(LOOCV_total),]
          LOOCV_total <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(LOOCV_obs_total))
        }
      }
      
    }else{
      # if there not enough observations, take the raw model
      print("**WARNING: Not enough observations. This date will not be corrected**")
      
      slope_v[i]  <- NA
      inter_v[i]  <- NA
      r_v[i]      <- NA
      
      if(execute_uk){
        UK_total_uncert_df[[count_i]]       <- rep(NA, length(df_model_uk))  #fill uncertainty file with nans in case uk cannot be performed
        UK_total_df[[count_i]]              <- as.numeric(df_model_uk$pollutant_model)
      }
      if(execute_loocv){
        # uk_loocv_h             <- matrix(NA, nrow = 1, ncol = nrow(local_stations))
        # colnames(uk_loocv_h )  <- local_stations@data$ref_obs
        # LOOCV_total            <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
        
        LOOCV_total <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(ok_hour))
      }
    }
    
    #TODO CHECK add date_i to LOOCV_total?
    # to avoid running final block
    if("date" %in% colnames(LOOCV_total)){
      if(time_resolution=="hourly"){
        LOOCV_total$date[nrow(LOOCV_total)] <- as.POSIXct(date_times[i,1],format="%Y%m%d %H",tz="UTC")
      }else if(time_resolution=="daily"){
        LOOCV_total$date[nrow(LOOCV_total)] <- as.POSIXct(dates[i],format="%Y%m%d",tz="UTC")
      }
    }else{
      if(time_resolution=="hourly"){
        LOOCV_total$date <- as.POSIXct(date_times[i,1],format="%Y%m%d %H",tz="UTC")
      }else if(time_resolution=="daily"){
        LOOCV_total$date <- as.POSIXct(dates[i],format="%Y%m%d",tz="UTC")
      }
    }
    
    # If there is no raw model available, fill with NAs
  } else{ 
    print(paste0("WARNING: The model is corrupted or non-existent in: ", date_i))
    if(execute_uk){
      UK_total_df[[count_i]]              <- rep(NA, length(df_model_uk))
      UK_total_uncert_df[[count_i]]       <- rep(NA, length(df_model_uk))
    }
    if(execute_loocv){
      
      uk_loocv_h             <- matrix(NA, nrow = 1, ncol = nrow(local_stations))
      colnames(uk_loocv_h )  <- local_stations@data$ref_obs
      LOOCV_total            <- plyr::rbind.fill(as.data.frame(LOOCV_total),as.data.frame(uk_loocv_h))
    }
    
    #TODO CHECK add date_i to LOOCV_total?
    if("date" %in% colnames(LOOCV_total)){
      if(time_resolution=="hourly"){
        LOOCV_total$date[nrow(LOOCV_total)] <- as.POSIXct(date_times[i,1],format="%Y%m%d %H",tz="UTC")
      }else if(time_resolution=="daily"){
        LOOCV_total$date[nrow(LOOCV_total)] <- as.POSIXct(dates[i],format="%Y%m%d",tz="UTC")
      }
    }else{
      if(time_resolution=="hourly"){
        LOOCV_total$date <- as.POSIXct(date_times[i,1],format="%Y%m%d %H",tz="UTC")
      }else if(time_resolution=="daily"){
        LOOCV_total$date <- as.POSIXct(dates[i],format="%Y%m%d",tz="UTC")
      }
    }
  }
  #extract date of the following hour
  # if(i != length(available_dates_model)){
  if(i != length_loop){
    date_i <- df_uk_observations[i+1,"date"] %>%
      lubridate::date()
    
    # check if this is the last iteration before changing to a new day
    if(date_i > date_0){
      print(paste0("saving ", date_0))
      saveRDS(UK_total_df,
              paste0(save_result,"UK_",file_format,"_",pollutant,
                     if (execute_uk_gbm) "_gbm_" else "_",
                     strftime(date_0,"%Y%m%d") ,".rds"))
      
      #saving uncertainty
      saveRDS(UK_total_uncert_df,
              paste0(save_result,"UK_",file_format,"_",pollutant,
                     if (execute_uk_gbm) "_gbm_uncertainty_" else "_uncertainty_",
                     strftime(date_0,"%Y%m%d") ,".rds"))
      
      # save as csv (rows are model cells, cols are days/hours)
      # do.call(rbind, UK_total_df) %>% 
      #   t() %>%
      #   as.data.frame() %>%
      #   write.table(file=paste0(save_result,"UK_",file_format,"_",pollutant, 
      #                         if (execute_uk_gbm) "_gbm_" else "_",
      #                         strftime(date_0,"%Y%m%d") ,".csv"),
      #             sep=",",row.names=F,col.names=F)
      
      date_0 <- date_i
      count_i <- 0
      
      #restart object
      UK_total_df <- list()
      UK_total_uncert_df <- list()
    }
    #save the last day 
  }else{
    print("last day... saving")
    saveRDS(UK_total_df,
            file = paste0(save_result,"UK_",file_format,"_",pollutant,
                          if (execute_uk_gbm) "_gbm_" else "_",
                          strftime(date_0,"%Y%m%d") ,".rds"))
    
    #saving uncertainty
    saveRDS(UK_total_uncert_df,
            paste0(save_result,"UK_",file_format,"_",pollutant,
                   if (execute_uk_gbm) "_gbm_uncertainty_" else "_uncertainty_",
                   strftime(date_0,"%Y%m%d") ,".rds"))
    
    # save as csv (rows are model cells, cols are days/hours)
    # do.call(rbind, UK_total_df) %>% 
    #   t() %>%
    #   as.data.frame() %>%
    #   write.table(file=paste0(save_result,"UK_",file_format,"_",pollutant, 
    #                         if (execute_uk_gbm) "_gbm_" else "_",
    #                         strftime(date_0,"%Y%m%d") ,".csv"),
    #               sep=",",row.names=F,col.names=F)
    
  }
  
}

print(paste("RAW MODEL USED",count_raw,"TIMES"))
print(paste("Interpolation of observations USED",count_obs,"TIMES"))

# force positive values
LOOCV_total <- LOOCV_total %>%
  dplyr::select(date,everything()) %>%
  mutate(across(where(is.numeric), ~ ifelse(. < 0, 0, .)))

# delete ghost prefixes and suffixes in the stations names
colnames(LOOCV_total) <- colnames(LOOCV_total) %>%
  gsub("STA_","",.) %>% gsub("\\_.*","",.) %>% gsub("STA-","",.)

# drop duplicated columns
LOOCV_total <- LOOCV_total[,!duplicated(colnames(LOOCV_total))]

# Set LOOCV_total_df with dates
# if(execute_loocv){
#   LOOCV_total_df        <- as.data.frame(LOOCV_total)
#   # force positive values
#   for(i in 1:nrow(local_stations)){
#     LOOCV_total_df[[i]] <- replace(LOOCV_total_df[[i]], LOOCV_total_df[[i]]<0, 0)
#   } 
#   
#   if(time_resolution=="hourly"){
#     LOOCV_total_df        <- cbind(date = date_times$date, LOOCV_total_df)
#   }else if(time_resolution=="daily"){
#     LOOCV_total_df        <- cbind(date = dates, LOOCV_total_df)
#     # LOOCV_total_df        <- cbind(date = available_dates_model, LOOCV_total_df)
#     LOOCV_total_df$date <- as.Date(LOOCV_total_df$date, format = "%Y%m%d")
#     
#   }else{
#     print("Wrong time_resolution")
#   }
# }



if (save_LOOCV){
  if(execute_loocv){
    # saveRDS(LOOCV_total_df, paste0(save_result,"LOOCV_",file_format,"_",pollutant,
    #                                if(execute_uk_gbm)"_gbm_" else "_", "df.rds"))
    saveRDS(LOOCV_total, paste0(save_result,"LOOCV_",file_format,"_",pollutant,
                                if(execute_uk_gbm)"_gbm_" else "_", "df.rds"))
    print("LOOCV saved")
  }
  
} else {
  print("LOOCV - UK not saved")
}

end_time_UK_LOOCV     <- Sys.time()
temps_total_UK_LOOCV  <- end_time_UK_LOOCV  - start_time_UK_LOOCV 
print(paste0("UK or LOOCV, execution time:",temps_total_UK_LOOCV))
