############################################################
#                                                          #
#              evaluation statistics                       #
#                                                          #
############################################################

# it alerts us if the dates in model do not coincide with the dates of the obs

# if ( any(date_times$date != df_obs_sub$date))  {
#   print("Warning: dates from model and observations are different")
# }
# no se si treure'l o bé, posar un if segons la time_resolution

#-------------------------------------------------------------------------------
# We will generate a list with the names in local stations that are in df_obs_sub:
names_local_stations <- as.list(intersect(local_stations@data$ref_obs, colnames(df_obs_sub)))
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# data frame with burnes data
burnes_matrix           <- matrix(NA,ncol=length(names_local_stations), length_loop)
df_burnes_all           <- data.frame(burnes_matrix)
colnames(df_burnes_all) <- names_local_stations


for( station_code in names_local_stations){
  # station_code <- names_local_stations[[1]]
  # Read burns data
    label <- paste0(burnes_path,"Cross_Validation_",station_code,".csv")
    if (file.exists(label)) {
      df <- read.csv(label, header = TRUE)
      
    df_dates       <- data.frame(date=as.character(df_obs_sub$date))
    colnames(df)   <- c("date","pollutant")
    df_merged      <- merge(x=df, y=df_dates, by = "date", all = TRUE)
    burnes_loocv   <- df_merged[,c(2)]
      
    } else{
      burnes_loocv <- NA
    }
    if(length(burnes_loocv)>length_loop){
      print("WARNING: length data from burnes is larger than observational data, chek it")
    }
  df_burnes_all[,station_code] <- burnes_loocv
}

df_burnes_all$date             <- df_obs_sub$date




# # Read burns data
# label <- paste0(burnes_path,"Cross_Validation_",station_code,".csv")
#   if (file.exists(label)) {
#   df <- read.csv(label, header = TRUE)
#   burnes_loocv <-df[,c(2)]
# } else{
#   burnes_loocv <- NA
# }
#-------------------------------------------------------------------------------



# Legislative values (daily max for no2):

#NOTA: Gene LOOCV s'avalua a escala horària, mitjana diària i màxim diàri
if( pollutant=="nox"){
  
  
  ############################################################
  #                          MÀXIM                           #
  ############################################################
  # Group data by date and find maximum value for each local station
  #aggregate de la llibreria sp
  max_obs_daily               <- aggregate(subset(df_obs_sub, select=names(df_obs_sub) %in% names_local_stations), 
                                           by=list(date=format(df_obs_sub$date, "%Y-%m-%d")), max)
  
  max_raw_mod_daily           <- aggregate(subset(model_raw_at_AQMS_df, select=names(model_raw_at_AQMS_df) %in% names_local_stations), 
                                           by=list(date=format(model_raw_at_AQMS_df$date, "%Y-%m-%d")), max)
  
  max_corrected_loocv_daily   <- aggregate(subset(LOOCV_total_df, select=names(LOOCV_total_df) %in% names_local_stations), 
                                           by=list(date=format(LOOCV_total_df$date, "%Y-%m-%d")), max)
  
  max_burnes_daily            <- aggregate(subset(df_burnes_all, select=names(df_burnes_all) %in% names_local_stations), 
                                           by=list(date=format(df_burnes_all$date, "%Y-%m-%d")), max)
  ############################################################
  #                             19 MAX                       #
  ############################################################
  max19_obs <- NULL
  
  obs_matrix           <- matrix(NA,ncol=length(names_local_stations),nrow=length_loop)
  obs_df               <- data.frame(obs_matrix)
  colnames(obs_df)     <- names_local_stations
  
  for(station_code in names_local_stations){
    #station_code <- names_local_stations[[1]]
    obs_df[,station_code] <- sort(df_obs_sub[,station_code], decreasing=TRUE,na.last=TRUE)
  }
  
  df_19max_obs <- obs_df[1,]
  
  
  #anual
  # max19_obs_annual <- aggregate(subset(df_obs_sub, select = names(df_obs_sub) %in% names_local_stations),
  #                               by = list(station = names_local_stations,
  #                                         year = format(df_obs_sub$date, "%Y")),
  #                               FUN = function(x) {
  #                                 sort(x, decreasing = TRUE)[19]
  #                               })
  
  
  ############################################################
  #                          MITJANA                         #
  ############################################################
  # Group data by date and find mean value for each local station
  mean_obs_daily               <- aggregate(subset(df_obs_sub, select=names(df_obs_sub) %in% names_local_stations), 
                                           by=list(date=format(df_obs_sub$date, "%Y-%m-%d")), mean)
  
  # Per que sigui media anual:
  #mean_obs_yearly <- aggregate(subset(df_obs_sub, select=names(df_obs_sub) %in% names_local_stations),
                               #by=list(year=format(df_obs_sub$date, "%Y")), mean)
  
  
  mean_raw_mod_daily           <- aggregate(subset(model_raw_at_AQMS_df, select=names(model_raw_at_AQMS_df) %in% names_local_stations), 
                                           by=list(date=format(model_raw_at_AQMS_df$date, "%Y-%m-%d")), max)
  
  mean_corrected_loocv_daily   <- aggregate(subset(LOOCV_total_df, select=names(LOOCV_total_df) %in% names_local_stations), 
                                           by=list(date=format(LOOCV_total_df$date, "%Y-%m-%d")), mean)
  
  mean_burnes_daily            <- aggregate(subset(df_burnes_all, select=names(df_burnes_all) %in% names_local_stations), 
                                           by=list(date=format(df_burnes_all$date, "%Y-%m-%d")), mean)
  
  ############################################################
  #                          MAX ALL AQMS                    #
  ############################################################
  # Group data by date and find maximum value for each local station
  #aggregate de la llibreria sp
  max_obs_daily               <- df_obs_sub
  
  max_raw_mod_daily           <- model_raw_at_AQMS_df
  
  max_corrected_loocv_daily   <- aggregate(subset(LOOCV_total_df, select=names(LOOCV_total_df) %in% names_local_stations), 
                                           by=list(date=format(LOOCV_total_df$date, "%Y-%m-%d")), max)
  
  max_burnes_daily            <- aggregate(subset(df_burnes_all, select=names(df_burnes_all) %in% names_local_stations), 
                                           by=list(date=format(df_burnes_all$date, "%Y-%m-%d")), max)
    
    
  }
 
#-------------------------------------------------------------------------------
#We need a data.frame with raw_model and LOOCV_model to apply the stadistics

# Comparation using all stations concatenated:
raw_model_total         <- NULL
UK_model_total          <- NULL 
Burnes_model_total      <- NULL 
geostats_results        <- NULL

for (station_code in names_local_stations) {
  # station_code <- names_local_stations[[18]]
  obs_station       <- df_obs_sub[ ,station_code]
  raw_model_estacio <- data.frame(obs = obs_station,
                                  mod = model_raw_at_AQMS_df[ ,station_code], 
                                  model="raw_model")
  UK_model_estacio <-   data.frame(obs = obs_station,
                                   mod = LOOCV_total_df[ ,station_code],
                                   model="UK_model")
  # # Read burns data
  # label <- paste0(burnes_path,"Cross_Validation_",station_code,".csv")
  #   if (file.exists(label)) {
  #   df <- read.csv(label, header = TRUE)
  #   burnes_loocv <-df[,c(2)]
  # } else{
  #   burnes_loocv <- NA
  # }
  
   Burnes_model_estacio <-   data.frame(obs = obs_station,
                                        mod =df_burnes_all[,station_code],
                                        model="burnes_model")
  
  # Statistics for a single station
  Raw_geostats    <- openair::modStats(raw_model_estacio, obs = "obs", mod = "mod", type = "model")
  UK_geostats     <- openair::modStats(UK_model_estacio, obs = "obs", mod = "mod", type = "model")
  Burnes_geostats <- openair::modStats(Burnes_model_estacio, obs = "obs", mod = "mod", type = "model")
  
  geostats_station <- data.frame(x=local_stations@coords[which(local_stations@data$ref_obs == station_code),1],
                                 y=local_stations@coords[which(local_stations@data$ref_obs == station_code),2],
                                 ref = station_code,
                                 COE_raw = Raw_geostats$COE,
                                 COE_UK = UK_geostats$COE,
                                 COE_Burnes = Burnes_geostats$COE,
                                 MB_raw = Raw_geostats$MB,
                                 MB_UK = UK_geostats$MB,
                                 MB_Burnes = Burnes_geostats$MB)
  
  # Gather all stations
  geostats_results    <- rbind(geostats_results,geostats_station)
  #raw_model_total and corr_model_total are a data frame with three lists (obs, mod, model(raw or corrected))
  raw_model_total     <- rbind(raw_model_total,raw_model_estacio) 
  UK_model_total      <- rbind(UK_model_total,UK_model_estacio)
  Burnes_model_total  <- rbind(Burnes_model_total,Burnes_model_estacio)
}

mod_obs_data <- rbind(raw_model_total,
                      UK_model_total,
                      Burnes_model_total)

#Openair function that gives us the stadistics we want

Summary_stats <- openair::modStats(mod_obs_data, obs = "obs", mod = "mod", type = "model")
print(Summary_stats)
png(file = paste0(save_general_statistics,"All_stations_",pollutant,"_stats.png"), width = 1472, height = 540)
gridExtra::grid.table(Summary_stats)
dev.off()

print("Statistic for all stations concateneited: ")

##
## Map Statistics
##



geostats_results <- na.omit(geostats_results)

coordinates(geostats_results)        <- ~ x + y
sp::proj4string(geostats_results)    <- crs_latlon

a <- mapview::mapview(geostats_results, zcol = "COE_UK", legend = TRUE,at=c(-10,-0.5,0,0.5,1))
b <- mapview::mapview(geostats_results, zcol = "COE_Burnes", legend = TRUE,at=c(-10,-0.5,0,0.5,1))

c <- mapview::mapview(geostats_results, zcol = "MB_UK", legend = TRUE,at=c(-35,-12,-10,-5,0,5,10,12,20,45))
d <- mapview::mapview(geostats_results, zcol = "MB_Burnes", legend = TRUE,at=c(-35,-12,-10,-5,0,5,10,12,20,45))


#to save it in htm:
mapshot(a,paste0(save_result,"COE_UK.html"))
mapshot(b,paste0(save_result,"COE_Burnes.html"))


mapshot(c,paste0(save_result,"MB_UK.html"))
mapshot(d,paste0(save_result,"MB_Burnes.html"))



#-------------------------------------------------------------------------------
# Mean value for each hour all stations:
obs_total_mean            <- matrix(nrow = length_loop, ncol = 0) 
raw_model_total_mean      <- matrix(nrow = length_loop, ncol = 0)
UK_model_total_mean       <- matrix(nrow = length_loop, ncol = 0)
Burnes_model_total_mean   <- matrix(nrow = length_loop, ncol = 0)

for (station_code in names_local_stations) {
  obs_station <- df_obs_sub[ ,station_code]
  # station_code <- local_stations@data$code[1]
  
  raw_model_estacio  <-  model_raw_at_AQMS_df[ ,station_code]
  UK_model_estacio   <-  LOOCV_total_df[ ,station_code]
  
  # # Read burns data
  # label <- paste0(burnes_path,"Cross_Validation_",station_code,".csv")
  # if (file.exists(label)) {
  #   df <- read.csv(label, header = TRUE)
  #   burnes_loocv <-df[,c(2)]
  # } else{
  #   burnes_loocv <- NA
  # }
  
  
  obs_total_mean          <- cbind(obs_total_mean,obs_station)
  raw_model_total_mean    <- cbind(raw_model_total_mean,raw_model_estacio)
  UK_model_total_mean     <- cbind(UK_model_total_mean,UK_model_estacio)
  Burnes_model_total_mean <- cbind(Burnes_model_total_mean,df_burnes_all[,station_code])
}

raw_model_mean      <- data.frame( obs = rowMeans(obs_total_mean,na.rm=TRUE),
                                   mod = rowMeans(raw_model_total_mean,na.rm=TRUE),
                                   model="raw_model")

UK_model_mean     <- data.frame(   obs = rowMeans(obs_total_mean,na.rm=TRUE),
                                   mod = rowMeans(UK_model_total_mean,na.rm=TRUE),
                                   model="UK_model")

Burnes_model_mean     <- data.frame( obs = rowMeans(obs_total_mean,na.rm=TRUE),
                                     mod = rowMeans(Burnes_model_total_mean,na.rm=TRUE),
                                     model="Burnes_model")

mod_obs_data_mean   <- rbind(raw_model_mean,
                             UK_model_mean,
                             Burnes_model_mean)


Summary_stats <- openair::modStats(mod_obs_data_mean, obs = "obs", mod = "mod", type = "model")
print(Summary_stats)

png(file = paste0(save_general_statistics,"All_stations_hourly_",pollutant,"_stats.png"), width = 1472, height = 540)
gridExtra::grid.table(Summary_stats)
dev.off()

print("Statistic considering the mean hour for all stations: ")

#-------------------------------------------------------------------------------
# Per una estació:
# First, we will evalue the raw model. To do so, we need a data frame with obs and the raw model. Obv we choose df_obs_sub as obs
# colnames(model_raw_at_AQMS)[1] --> We do the stadistics for each station
# 
# raw_model <- data.frame( obs = df_obs_sub[ ,colnames(model_raw_at_AQMS)[1] ],
#                          mod = model_raw_at_AQMS_df[ ,colnames(model_raw_at_AQMS)[1]],
#                          model="raw_model")
# 
# #Aqui posarem el LOOC_total_df  que s'ha anat generant en el bucle amb el model corretgit
# corr_model <- data.frame( obs = df_obs_sub[ ,colnames(model_raw_at_AQMS)[1] ],
#                           mod = LOOCV_total_df[ ,colnames(model_raw_at_AQMS)[1]],
#                           model="corr_model")
# 
# #tres columnes: obs, mod i quin tipus de model es 'model': que pot ser raw_model o corr_model. Primer et posa el raw i seguidament el corr
# mod_obs_data_1 <- rbind(raw_model,
#                       corr_model)
# 
# # create evaluation statistics
# print("Example of the statistics for one station: ")
# Summary_stats <- openair::modStats(mod_obs_data_1, obs = "obs", mod = "mod", type = "model")
# print(Summary_stats)
############################################################
#                                                          #
#              Temporal variations                         #
#                                                          #
############################################################
#-------------------------------------------------------------------------------
# Plot per la mitjana de totes les estacions:

#First, we create a matrix to put the data of observations and model (corrected and raw)
obs_total          <- matrix(nrow = length_loop, ncol = 0) 
raw_model_total    <- matrix(nrow = length_loop, ncol = 0)
UK_model_total     <- matrix(nrow = length_loop, ncol = 0)
Burnes_model_total <- matrix(nrow = length_loop, ncol = 0)

for (station_code in names_local_stations) {
  
  #if (station_code %in% colnames(df_obs_sub)) {obs_station <- df_obs_sub[ ,station_code]}
  #else {obs_station <- NA}  
  
  obs_total          <- cbind(obs_total, df_obs_sub[ ,station_code])
  raw_model_total    <- cbind(raw_model_total,model_raw_at_AQMS_df[ ,station_code])
  UK_model_total     <- cbind(UK_model_total,LOOCV_total_df[ ,station_code])
  Burnes_model_total <- cbind(Burnes_model_total,df_burnes_all[,station_code])
}

#Then, we calculate the means of each hour considering the whole stations
raw_model <- data.frame( obs = rowMeans(obs_total,na.rm=TRUE),
                         mod = rowMeans(raw_model_total,na.rm=TRUE),
                         model="raw_model")

UK_model <- data.frame(   obs = rowMeans(obs_total,na.rm=TRUE),
                          mod = rowMeans(UK_model_total,na.rm=TRUE),
                          model="corr_model")

Burnes_model <- data.frame(   obs = rowMeans(obs_total,na.rm=TRUE),
                              mod = rowMeans(Burnes_model_total,na.rm=TRUE),
                              model="corr_model")


Mean_all_stations            <- data.frame(date               = df_obs_sub$date,
                                           observations       = raw_model$obs,
                                           raw_Model          = raw_model$mod, 
                                           UK_Model           = UK_model$mod,
                                           Burnes_Model       = Burnes_model$mod)

TIME_VAR <- openair::timeVariation(Mean_all_stations,
                                   pollutant = c("observations","raw_Model","UK_Model","Burnes_Model"),
                                   ylab = paste0(pollutant, " ", "(ug/m3)"),
                                   type ="month",
                                   key = TRUE,
                                   title = "Media horaria Cat",
                                   auto.text=FALSE,
                                   ci = FALSE,
                                   #conf.int = c(0.75, 0.99),
                                   ylim = c(0, 100),
                                   cols = c("black", "grey", "green","brown"),
                                   lty = c("solid","solid","solid","solid"),
                                   lwd = c(8,2,2,2), 
                                   name.pol = c("Observations", "Raw model", "UK Model","Burnes Model"))  

png(file = paste0(save_general_statistics,"temporal_",pollutant,"_mean_time_VAR.png"), width = 800, height = 600)
print(TIME_VAR[[1]][3])  # per pm! [1][2] no2 i o3
dev.off()
#-------------------------------------------------------------------------------
# Plot per cada estació:


for (station_code in names_local_stations) {
  
  # station_code <- names_local_stations[[1]]
  #if (station_code %in% colnames(df_obs_sub)) {obs_station <- df_obs_sub[ ,station_code]
  #} else {obs_station <- NA}  
  
  Single_station            <- data.frame(date               = df_obs_sub$date,
                                          observations       = df_obs_sub[ ,station_code],
                                          raw_Model          = model_raw_at_AQMS_df[ ,station_code], 
                                          UK_corrected       = LOOCV_total_df[ ,station_code],
                                          Burnes_corrected   = df_burnes_all[,station_code])
  
  TIME_VAR <- openair::timeVariation(Single_station,
                                     pollutant = c("observations","raw_Model","UK_corrected","Burnes_corrected"),
                                     ylab = paste0(pollutant, " ", "(ug/m3)"),
                                     type ="month",
                                     key = TRUE,
                                     title = station_code,
                                     auto.text=FALSE, 
                                     ci = FALSE,
                                     conf.int = c(0.75, 0.99),
                                     ylim = c(0, 100),
                                     cols = c("black", "grey", "green","brown"),
                                     lty = c("solid","solid","solid","solid"),
                                     lwd = c(8,2,2,2), 
                                     name.pol = c("Observations", "Raw model", "UK Model","Burnes Model"))  
  png(file = paste0(save_temporal_variation,station_code,"_",pollutant,"_time_VAR.png"), width = 800, height = 600)
  print(TIME_VAR[[1]][3]) #same 
  dev.off()
  
}



TIME_VAR <- openair::timeVariation(Single_station,
                                   pollutant = c("observations","raw_Model","Burnes_corrected"),
                                   ylab = paste0(pollutant, " ", "(ug/m3)"),
                                   type ="month",
                                   key = TRUE,
                                   title = station_code,
                                   auto.text=FALSE, 
                                   ci = FALSE,
                                   conf.int = c(0.75, 0.99),
                                   ylim = c(0, 100),
                                   cols = c("black", "grey", "green"),
                                   lty = c("solid","solid","solid"),
                                   lwd = c(8,2,2), 
                                   name.pol = c("Observations", "Raw model","Burnes Model"))  
print(TIME_VAR[[1]][2]) #same 
############################################################
#                                                          #
#                   Time series                            #
#                                                          #
############################################################

# Plot per cada estació:
model_raw_at_AQMS=model_raw_at_AQMS_df

month_names = c("August")
for (station_code in names_local_stations) {
  
  # station_code <- names_local_stations[[1]]
  data_single     <- data.frame(date               = df_obs_sub$date,
                                observations       = df_obs_sub[ ,station_code],
                                Raw_Model          = model_raw_at_AQMS_df[ ,station_code], 
                                UK_Model           = LOOCV_total_df[ ,station_code],
                                Burnes_Model       = df_burnes_all[,station_code])
  
  for (mm in month_names) { #no2, o3 per hora o dia separar (pm treure for)
    # TIME_PLOT
    png(file = paste0(save_time_series,station_code,"_",pollutant,"_r_",mm,".png"), width = 800, height = 400)
    openair::timePlot(data_single, #openair::selectByDate(data_single, year=read_year, month = mm),
                      pollutant = c("observations","Raw_Model","UK_Model","Burnes_Model"),
                      group = TRUE,                                    
                      title = station_code,
                      auto.text=FALSE, 
                      plot.type = "l", #for o3 and no2
                      ci = FALSE,
                      #plot.type = "h", #for pm
                      conf.int = c(0.75, 0.99),
                      ylim = c(0, 150),
                      cols = c("black", "blue", "grey","red"),
                      lty = c("solid","solid","solid","solid"),
                      lwd = c(5,6,3,2),
                      name.pol = c("Observations", "Raw model", "UK Model","Burnes Model"))
    dev.off()
  }
}

# #només era per plotat UK & BUrnes per una estació det
# for (mm in month_names) { #no2, o3 per hora o dia separar (pm treure for)
#   # TIME_PLOT
#   openair::timePlot(data_single, #openair::selectByDate(data_single, year=read_year, month = mm),
#                     pollutant = c("observations","UK_Model","Burnes_Model"),
#                     group = TRUE,
#                     title = station_code,
#                     auto.text=FALSE,
#                     plot.type = "l",
#                     ci = FALSE,
#                     #plot.type = "h",
#                     conf.int = c(0.75, 0.99),
#                     ylim = c(0, 200),
#                     cols = c("black", "blue","red"),
#                     lty = c("solid","solid","solid"),
#                     lwd = c(5,3,2),
#                     name.pol = c("Observations", "UK Model","Burnes Model"))
#   dev.off()
# }





# UK
for (station_code in names_local_stations) {
  
  # station_code <- names_local_stations[[1]]
  data_single     <- data.frame(date               = df_obs_sub$date,
                                observations       = df_obs_sub[ ,station_code],
                                Raw_Model          = model_raw_at_AQMS_df[ ,station_code], 
                                UK_Model           = LOOCV_total_df[ ,station_code])
  
  for (mm in month_names) { #no2, o3 per hora o dia separar (pm treure for)
    # TIME_PLOT
    png(file = paste0(save_time_series,station_code,"_",pollutant,"_uk_",mm,".png"), width = 800, height = 400)
    openair::timePlot(data_single, #openair::selectByDate(data_single, year=read_year, month = mm),
                      pollutant = c("observations","Raw_Model","UK_Model"),
                      group = TRUE,                                    
                      title = station_code,
                      auto.text=FALSE, 
                      plot.type = "h",
                      ci = FALSE,
                      #plot.type = "h",
                      conf.int = c(0.75, 0.99),
                      ylim = c(0, 150),
                      cols = c("black", "blue", "grey"),
                      lty = c("solid","solid","solid"),
                      lwd = c(5,6,2),
                      name.pol = c("Observations", "Raw model", "UK Model"))
    dev.off()
  }
}
# Bunes

for (station_code in names_local_stations) {
  
  # station_code <- names_local_stations[[1]]
  data_single     <- data.frame(date               = df_obs_sub$date,
                                observations       = df_obs_sub[ ,station_code],
                                Raw_Model          = model_raw_at_AQMS_df[ ,station_code], 
                                UK_Model           = LOOCV_total_df[ ,station_code],
                                Burnes_Model       = df_burnes_all[,station_code])
  
  for (mm in month_names) { #no2, o3 per hora o dia separar (pm treure for)
    # TIME_PLOT
    png(file = paste0(save_time_series,station_code,"_",pollutant,"_bunes_",mm,".png"), width = 800, height = 400)
    openair::timePlot(data_single, #openair::selectByDate(data_single, year=read_year, month = mm),
                      pollutant = c("observations","Raw_Model","Burnes_Model"),
                      group = TRUE,                                    
                      title = station_code,
                      auto.text=FALSE, 
                      plot.type = "h",
                      ci = FALSE,
                      #plot.type = "h",
                      conf.int = c(0.75, 0.99),
                      ylim = c(0, 150),
                      cols = c("black", "blue", "grey"),
                      lty = c("solid","solid","solid"),
                      lwd = c(5,6,2),
                      name.pol = c("Observations", "Raw model","Burnes Model"))
    dev.off()
  }
}
#-------------------------------------------------------------------------------
# Plot per la mitjana horària de totes les estacions:
#First, we create a matrix to put the data of observations and model (corrected and raw)

obs_total            <- matrix(nrow = length_loop, ncol = 0) 
raw_model_total      <- matrix(nrow = length_loop, ncol = 0)
corr_model_total     <- matrix(nrow = length_loop, ncol = 0)
Burnes_model_total   <- matrix(nrow = length_loop, ncol = 0)

for (station_code in names_local_stations) {
  #obs_estacio           <-  df_obs_sub[ ,colnames(model_raw_at_AQMS)[i]]
  #df_obs_sub_t          <-  subset(df_obs_sub, select=-date)
  
  obs_estacio           <-  df_obs_sub[ ,station_code]
  raw_model_estacio     <-  model_raw_at_AQMS_df[ ,station_code]
  corr_model_estacio    <-  LOOCV_total_df[ ,station_code]
  
  obs_total             <- cbind(obs_total,obs_estacio)
  raw_model_total       <- cbind(raw_model_total,raw_model_estacio)
  corr_model_total      <- cbind(corr_model_total,corr_model_estacio) 
  Burnes_model_total    <- cbind(Burnes_model_total,df_burnes_all[,station_code])
  
}

#Then, we calculate the means of each hour considering the whole stations
raw_model   <- data.frame( obs = rowMeans(obs_total,na.rm=TRUE),
                           mod = rowMeans(raw_model_total,na.rm=TRUE),
                           model="raw_model")

corr_model   <- data.frame( obs = rowMeans(obs_total,na.rm=TRUE),
                            mod = rowMeans(corr_model_total,na.rm=TRUE),
                            model="corr_model")

Burnes_model <- data.frame(   obs = rowMeans(obs_total,na.rm=TRUE),
                              mod = rowMeans(Burnes_model_total,na.rm=TRUE),
                              model="corr_model")


data_single   <- data.frame(date               = df_obs_sub$date,
                            observations       = raw_model$obs,
                            Model              = raw_model$mod,
                            Model_corrected    = corr_model$mod,
                            Burnes_Model       = Burnes_model$mod)


png(file = paste0(save_general_statistics,"time_series_","hourly_mean","_",pollutant,".png"), width = 800, height = 400)
openair::timePlot(data_single,
                  pollutant = c("observations","Model","Model_corrected","Burnes_Model"),
                  plot.type = "l",
                  group = TRUE,
                  y.relation = "free",
                  ylab= paste0(pollutant, " ", "(ug/m3)"),
                  cols = c("black", "blue", "grey","red"),
                  lty = c("solid","solid","solid","solid"),
                  lwd = c(5,6,2,2),
                  name.pol = c("observations","Raw model", "Corrected Model", "Burnes model"))
dev.off()




