# functions needed in other scripts of the repository

# function data_frame_dates, originally in urbanR
data_frame_dates <- function (date_time_begin = date_time_begin, 
                              date_time_end = date_time_end) {
  year_begin <- date_time_begin[1]
  month_begin <- date_time_begin[2]
  day_begin <- date_time_begin[3]
  hour_begin <- date_time_begin[4]
  year_end <- date_time_end[1]
  month_end <- date_time_end[2]
  day_end <- date_time_end[3]
  hour_end <- date_time_end[4]
  date_t_begin <- ISOdate(year_begin, month_begin, day_begin, 
                          hour_begin, tz = "UTC")
  date_t_end <- ISOdate(year_end, month_end, day_end, hour_end, 
                        tz = "UTC")
  all.dates <- data.frame(date = seq(ISOdatetime(year = year_begin, 
                                                 month = month_begin, day = day_begin, hour = hour_begin, 
                                                 min = 0, sec = 0, tz = "UTC"), ISOdatetime(year = year_end, 
                                                                                            month = month_end, day = day_end, hour = hour_end, min = 0, 
                                                                                            sec = 0, tz = "UTC"), by = "hour"))
  return(all.dates)
}



# function time_subset, originally in urbanR
time_subset <- function (data = data, 
                         time_var_name = "date_begin", 
                         date_time_begin = c(2013, 1, 1, 0), 
                         date_time_end = c(2013, 12, 31, 23)){
  year_begin <- date_time_begin[1]
  month_begin <- date_time_begin[2]
  day_begin <- date_time_begin[3]
  hour_begin <- date_time_begin[4]
  year_end <- date_time_end[1]
  month_end <- date_time_end[2]
  day_end <- date_time_end[3]
  hour_end <- date_time_end[4]
  date_time_begin <- ISOdate(year_begin, month_begin, day_begin, 
                             hour_begin, tz = "UTC")
  date_time_end <- ISOdate(year_end, month_end, day_end, hour_end, 
                           tz = "UTC")
  data_subset <- data[data[, time_var_name] >= date_time_begin & 
                        data[, time_var_name] <= date_time_end, ]
  if (nrow(data_subset) == 0) {
    print("dates are not available")
  }
  data_subset <- data_subset[!is.na(data_subset[, 1]), ]
  return(data_subset)
}
