############################################################
#                                                          #
#               load traffic                               #
#                                                          #
############################################################
#"/home/jmateu/Documents/Codes/geostats/microscale_LUR/roads/roadlinks_ES511.shp"
#els vull descarregar a : /esarchive/scratch/mhajji/Meriem/microscale_LUR/roads

roads     <-rgdal::readOGR("/esarchive/scratch/mhajji/Meriem/microscale_LUR/roads")
bcn_roads <- roads



# x_coords <- c(1.5,2.7,2.7,1.5)
# y_coords <- c(41,41,42,42)
x_coords <- c(1.9,2.25,2.25,1.9)
y_coords <- c(41.3,41.3,41.6,41.6)
poly1 <- sp::Polygon(cbind(x_coords,y_coords))
firstPoly <- sp::Polygons(list(poly1), ID = "A")
firstSpatialPoly <- sp::SpatialPolygons(list(firstPoly))
sp::proj4string(firstSpatialPoly) <- sp::CRS(crs_latlon)
spatial_context <- sf::st_as_sf(firstSpatialPoly)

mapview::mapview(spatial_context) +sp_all_campaigns
mapview::mapview(roads_trafficvol)

roads_sf <- sf::st_as_sf(roads, coords = c("lon", "lat"), crs = crs_latlon) 

roads_trafficvol <- dplyr::filter(roads_sf, trafficvol > 0)

roads <- sf::st_intersection(roads_trafficvol, spatial_context)

roads_sf <- sf::st_transform(roads,"+proj=utm +zone=31 +ellps=intl +units=m +no_defs") 


roads_all <- rbind(roads_all,roads_bcn)
roads_all <- rbind(roads_all,roads_Lleida)
roads_all <- rbind(roads_all,roads_tarragona)

# %%>%%
#   sf::st_transform(%crs_sim%)



mapview::mapview(roads) + sp_all_campaigns



############################################################
#                                                          #
#               make buffers                               #
#                                                          #
############################################################
area_type <- "buffer"

#buffer_elements = c( 50, 250, 2500, 5000)

sf_all_campaigns <- sf::st_as_sf(sp_all_campaigns)
sf_all_campaigns_utm <- sf::st_transform(sf_all_campaigns,"+proj=utm +zone=31 +ellps=intl +units=m +no_defs") 

#sf_buffers <- sf::st_buffer(sf_all_campaigns_utm,dist=buffer)

buffer <- 1000
all_campaigns$traffic_1km<- traffic_density_index(sf_all_campaigns_utm, buffer)
buffer <- 10000
all_campaigns$traffic_10km<- traffic_density_index(sf_all_campaigns_utm, buffer)
buffer <- 50000
all_campaigns$traffic_50km<- traffic_density_index(sf_all_campaigns_utm, buffer)  


traffic_density_index <- function(sf_all_campaigns_utm,buffer) {
  sf_buffers <- sf::st_buffer(sf_all_campaigns_utm,dist=buffer)
  traffic_density_index <- numeric()
  for(i in 1:nrow(sf_buffers)){
    roads_context <- sf::st_intersection(roads_sf, sf_buffers[i,])
    lengths <- sf::st_length(roads_context)
    class(lengths) <- setdiff(class(lengths), "units")
    lengths <- as.numeric(lengths) # m
    #surfaces <- lengths * 3 * 2.5 # m2
    #total_surf <- pi * 564 * 564
    #roads_context$vehicles_m2 <- roads_context$aadt /surfaces
    #roads_context$rel_surf <- surfaces /total_surf
    roads_context$Imd_s <- roads_context$trafficvol/(3600*24)
    # estimate vehicles / m
    #traffic_density_index[i] <-  sum(roads_context$Imd_s *  lengths) * 1.47#/ total_surf
    traffic_density_index[i] <-  sum(roads_context$Imd_s *  lengths) 
  }
  return(traffic_density_index)
}
